uk.ac.starlink.table

## Interface RowSequence

- All Superinterfaces:
    java.lang.AutoCloseable, java.io.Closeable, RowData, Sequence
  All Known Subinterfaces:
    RowSplittable
  All Known Implementing Classes:
    AccessRowSequence, CountCheckRowSequence, EmptyRowSequence, IteratorRowSequence, MappingRowSplittable, OnceRowPipe, ProgressRowSplittable, RandomRowSplittable, ReaderRowSequence, SequentialRowSplittable, WrapperRowSequence

      public interface RowSequence
      extends java.io.Closeable, RowData, Sequence

  Provides sequential access to the data in a table. The data is a sequence of rows which may be processed from the first to the last. A RowSequence iterates over the rows one at a time. It starts off positioned before the first row, so the `next` method must be invoked before the first row can be accessed.

  Typical usage might look like this:

           RowSequence rseq = table.getRowSequence();
           try {
               while ( rseq.next() ) {
                   Object[] row = rseq.getRow();
                      ...
               }
           }
           finally {
               rseq.close();
           }

  A RowSequence cannot in general be expected to be used safely from multiple threads.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Indicates that this sequence will not be required any more.
    `java.lang.Object` | `getCell(int icol)` Returns the contents of a cell in the current row.
    `java.lang.Object[]` | `getRow()` Returns the contents of the current table row, as an array with the same number of elements as there are columns in this table.
    `boolean` | `next()` Attempts to advance the current row to the next one.

- - ### Method Detail

    - #### next

          boolean next()
                throws java.io.IOException

      Attempts to advance the current row to the next one. If `true` is returned the attempt has been successful, and if `false` is returned there are no more rows in this sequence. Since the initial position of a RowSequence is before the first row, this method must be called before current row data can be accessed using the `getCell(int)` or `getRow()` methods.
      Specified by:
        `next` in interface `Sequence`
      Returns:
        `true` iff this sequence has been advanced to the next row
      Throws:
        `java.io.IOException` - if there is some error

    - #### getCell

          java.lang.Object getCell(int icol)
                            throws java.io.IOException

      Returns the contents of a cell in the current row. The class of the returned object should be the same as, or a subclass of, the class returned by `getColumnInfo(icol).getContentClass()`. An unchecked exception will be thrown if there is no current row (`next` has not yet been called).
      Specified by:
        `getCell` in interface `RowData`
      Parameters:
        `icol` - column index
      Returns:
        the contents of cell `icol` in the current row
      Throws:
        `java.io.IOException` - if there is an error reading the data
        `java.lang.IllegalStateException` - if there is no current row (before the start of the table)

    - #### getRow

          java.lang.Object[] getRow()
                             throws java.io.IOException

      Returns the contents of the current table row, as an array with the same number of elements as there are columns in this table. An unchecked exception will be thrown if there is no current row (`next` has not yet been called).
      Specified by:
        `getRow` in interface `RowData`
      Returns:
        an array of the objects in each cell in row `irow`
      Throws:
        `java.io.IOException` - if there is an error reading the data

    - #### close

          void close()
              throws java.io.IOException

      Indicates that this sequence will not be required any more. This should release resources associated with this object. The effect of calling any of the other methods following a `close` is undefined.
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.io.Closeable`
      Throws:
        `java.io.IOException`